PAGE 60,132
TITLE SYSREQ.Exe  Resident System Request Functions
               COMMENT @
------------------------------------------------------------------------

       Syntax:  SYSREQ {d:\Path\{FSpec}}    default = \SYSRQ.SCR

       Config:  ANSI.Sys Required, LoadHigh ability desirable.

       Program features:

         1) Saves Console Text to Disk on AT ... Print Screen key

         2) Traps User Alarm Int 4Ah with Messages ( AT Real-Time Clock )

              Use "SETALARM hh:mmx" to SET the RTC Alarm time, or
              execute INT4Ah.COM for Errors in Batch files, or
              call "Int 4Ah" for Errors in Programs.  Different
              messages are generated for the Alarm Clock and User
              Error conditions.

         4) Sounds Rising/Falling tones for Lock Keys ON/OFF

         5) Displays current settings of the RTC ... Alt+SysRQ key

            Displays DOS Error Information ( AX=

     SysReq.Exe will save Monochrome Buffer at B000h if Mode is 7, 86 or
   87.  If mode is 0 thru 3, 84 or 85, Color (B800h) Buffer is assumed,
   using BIOS parameters.  Graphics modes using A000h Buffer will sound
   Error tone if Dump is attempted, then Original Int 5h code is executed.

     PROPRIETY as well as Normal Screen modes dump using BIOS Screen Bytes
   and Columns [ INTEGER ( Bytes / 2 / Cols ) * ( Cols + 2 ) ].  40, 80 and
   132 column formats are supported as well as 25 to 31, 43, 50 and other
   Row formats.

     Total characters processed is computed from RAM BIOS data using both
   Columns and Screen Bytes to calculate possible Rows, then adding 6 if 25
   rows.  Some garbage will inevitably be output, though Propriety screen
   formats, unknown to DOS, will be saved properly if 25 to 31 Lines (One
   of the reasons this program was written was to process Propriety Screen
   formats using 26 to 120 lines, made possible by the newer VGA and SVGA
   Video adaptors.)

     Character data is output exactly as it is stored in the Video Buffer
   (ASCII 0 to 255).  43 Line modes (and up) output a Mirror image of the
   DISPLAYED screen.

     The program determines the Starting location within the Video Buffer
   from the Bios Offset for the current Display buffer.  Minimum Screen Bytes
   is verified using [ Cols * 25 * 2 ].  Error Code 98 ("Invalid ROM BIOS
   data") is generated if any anomalies are encountered during calculations.

     Programs that utilize Video Display Paging (other than 0) are processed
   correctly as long as Bios functions are used to set the Display Page.
   Updating pages other than the current Display Page will not affect the
   Screen data that is Saved to disk, until the data is actually Displayed.
   ( In other words, WYS = WYS, or What you SEE is what you SAVE ... )

     The maximum possible output byte size is 8,308 Bytes as of DOS 6.22,
   using BIOS values of [ 16,384 ] Screen Bytes and [ 132 ] columns.  Other
   modes that generate BIOS Byte values above 16kB are trapped on Error 98.
   The standard 80x25 Text modes output 4,100 Bytes or less.  Trailing
   spaces are truncated.  Blank lines will output only Cr, Lf.  The TOTAL
   File size (up to 64k) of the appended SysRQ.Scr file is indicated on the
   message.

     Ouput is to file \SYSRQ.SCR in the ROOT directory, unless another
   Path and/or File Name is specified at LOAD Time.  For Current directory,
   invoke loader with " SYSREQ SYSRQ.SCR ".  If UMBs are available, invoke
   loader as " LH /L:1,16384 SYSREQ.EXE " ( min = small .Exe size + 512 )
   Data is APPENDED to an Existing file, IF found, else one is created.

     Any standard DOS File Specification can be supplied at Load time to
   direct output to ANY Drive and/or Path and/or File.

     Standard DOS Error numbers and Messages are used if any errors are
   encountered.  Normal completion is indicated by displayed message. The
   ALT key is used as an Acknowledge (Ack) key to reset the display, though
   reset will occur automatically in 30 seconds or less.  (Displayed message
   Windows overlay the currently displayed Screen, then the original Screen
   contents are restored.)

     SysRQ adds EXTENSIONS to Interrupt 15h (Bios - Alt+SysRQ key, etc.),
   Int 1Ch (User Ticker at 18.2 times per second) and Int 4Ch (AT Real Time
   User Alarm).  Interrupt 5 (Print Screen) is replaced with a completely
   New and different routine.  SysRQ Loads itself when SYSREQ.EXE is first
   executed, then remains Resident, protected by DOS.

     All program functions are activated by special Key strokes or from
   another program using Interrupts.  Loading the AX Register with a value
   of 8501h then calling Interrupt 15h will invoke the AT RTC display feature
   (used by the SETALARM.COM program to verify Alarm Time).  Calling Int 4Ah
   when the Clock time is NOT equal to the Alarm time will invoke the User
   Error feature (Different message and location from Alarm feature).

     To UNLOAD Resident program, press Alt+SysRQ then hold Left AND Right
   SHIFT keys down immediately afterward.  TWO short Tones will signal that
   SysReq has been Unloaded.  To RE-LOAD, re-execute SYSREQ.EXE.  (See
   SYSREQ.BAT for options.)

     Unloading SysRQ replaces ALL of the Original Vectors to the state found
   at Load time.  Additional extensions added AFTER the SysRQ Loader will be
   lost when Unloaded.  If this creates a problem, make sure SysRQ is Loaded
   AFTER any Resident Programs that are affected.

     Relocated Interrupt Vectors are moved to Ints 85h, 86h, 8Ah and 8Ch.  If
   any of these are IN USE, SysRQ will NOT Load.  Contact the author if any
   conflict is encountered with these assignments.

     Since DOS Functions are NOT re-entrant, invoking SysRQ while DOS is
   actually RUNNING may hang up the system, though functions complete as
   normally expected.  Simply Re-Boot the system, then look for your data
   in the SysRQ.Scr file in the specified location on disk.  SysRQ calls
   have been extensively tested with the assumption that the system is
   IDLE, waiting for some Keyboard entry, etc.  The system WILL hang up
   if SysRQ is invoked while an application program is updating the Time
   of Day (such as an on-screen Clock) by invoking the DOS TOD Interrupts
   (Functions 2Ch and 2Dh of Int 21h - DOS Function Dispatcher).  This can
   be minimized by coding a routine that checks the TOD Ticker count in the
   ROM Bios RAM Data area (1st Byte at Addr 40:6Ch) against a saved value
   from the last update, and/or comparing the Keyboard HEAD and TAIL
   pointers (Words at 40:1Ah and 40:1Ch) to see if Keyboard data has
   actually been input.  In any event, Screen data will be saved to disk
   and rebooting will correct the problem.

     1995 I.P.  Ben Ritchey Jr.               Propriety Licensed Use Only 
@

               DOSSEG
               .MODEL  Small
               .STACK  800h    ; 2k Stack
               .386            ; Base Architecture

DGROUP         Group   _DATA, STACK
               Assume  cs:@code, ds:@data, ss:@data, es:@data

;  *** Warning ***  ALL Calls must be NEAR as:  [call Near Ptr x-x]  and
;      [retn].  (Loader and Runtime Procedures are FAR as a whole)

               Include SysReq.Inc  ; Data defs
               Include Macro.Inc
;  ==>  Note: Do NOT Include Called.Inc or Error.Inc !  <==
;             Do NOT Call Macros with Error traps ...
;       ( See before ERR_SET for Include of SysReq.Far Procs )
;         See SysReq.Inc for Include of StdError.Inc ...
;         See StdError.Inc for Include of DOSError.Inc ...

; ----------------------------------------------------------------------
; Mainline Code (Logic Stuff)
               .CODE

;    Program relocs Int 15h to NEW, traps 15h, calling NEW then ...
Start:         mov     ax,@data  ; Data Seg
               mov     ds,ax
               mov     RUNDS,ax
               mov     es,ax   ; Extra Seg
               mov     RUNES,ax
               mov     RUNCS,cs

               cli             ; Stack Seg=Data (Top) 
               mov     ss,ax
               mov     sp,Offset STACK
               mov     RUNSS,ss
               mov     RUNSP,sp
               sti

; Free extra RAM
               mov     ah,62h  ; Get PSP Seg
               int     DOS
               mov     PSPES,bx  ; 1st Seg/Page
               mov     es,bx

               mov     ax,RUNDS  ; Calculate ACTUAL Size  <==
               mov     bx,RUNSP  ; Convert Stack Ptr to Paras
               mov     cl,4
               shr     bx,cl   ;   to get Data + Stack (/16)
               add     ax,bx   ; Add Stack Pages to DS (End of Pgm)
               mov     bx,es   ; Get Start of Program (PSP)
               sub     ax,bx   ; Subtract Start from End
               add     ax,32   ; +512 Environment
               inc     ax      ; Laignappe
               mov     bx,ax   ; Now actual Seg/Page Size

SETSRQ:        mov     SRQPAGES,bx  ; No. Pages
               xor     al,al
               mov     ah,4Ah  ; Re-Allocate
               int     DOS
               jnc     Short @F
               jmp     ERR_SET

; Get DOS Version - Verify DOS >= 6.n
;      Out  al = Bin Major     ah = Bin Minor
@@:            mov     es,RUNES
               mov     ax,3000h
               int     DOS
               cmp     al,6
               jge     Short @F
               mov     al,99
               mov     RC,al
               jmp     ERR_EXIT

; Get Disk Transfer Addr - PSP +80h = Cmd Args
;      Out  es:bx = Current DTA
;           PBDTA = Saved DTA Offset    PBSDTA = Saved DTA Seg
@@:            mov     ax,2F00h
               int     DOS
               mov     PBDTA,bx
               mov     PBSDTA,es

               push    ds

               push    es      ; Save DTA Seg
               mov     es,RUNES
               pop     ds

               mov     di,Offset FSPECWC
               mov     si,bx
               mov     al,[si]
               cmp     al,2    ; Len=1 if No args
               jge     Short @F

               mov     al,DFSLEN  ; Use Default FSpec
               inc     al
               mov     si,Offset DFS
               dec     si
               dec     si
               pop     ds      ; Reset source Seg
               push    ds

@@:            xor     ch,ch
               mov     cl,al
               dec     cl
               inc     si
               inc     si
               cld

NXT_BYTE:      lodsb
               cmp     al,97
               jl      Short @F
               cmp     al,122
               jl      Short @F
               sub     al,32   ; Cv to Upper Case

@@:            cmp     al,' '
               je      Short @F  ; Skip all after 1st space
               stosb
               loop    NXT_BYTE

@@:            pop     ds

               mov     es,RUNES
               mov     cx,16   ; File(s) Msg
               mov     si,Offset FSPECWC
               mov     di,Offset DOFSPEC
               cld
               rep     movsd

; Check for Zero Interrupt Vectors 1st
               mov     es,IVEC_SEG

               mov     si,BIOSNEW
               mov     cl,2
               shl     si,cl
               cmp     Word Ptr es:[si],0  ; Offset
               jne     Short @F
               cmp     Word Ptr es:[si+2],0  ; Seg
               jne     Short @F

               mov     si,PSCRNEW
               shl     si,cl
               cmp     Word Ptr es:[si],0
               jne     Short @F
               cmp     Word Ptr es:[si+2],0
               jne     Short @F

               mov     si,UTICKNEW
               shl     si,cl
               cmp     Word Ptr es:[si],0
               jne     Short @F
               cmp     Word Ptr es:[si+2],0
               jne     Short @F

; Removed RTC Alarm logic 3-99 BJr
;               mov     si,ALARMNEW
;               shl     si,cl
;               cmp     Word Ptr es:[si],0
;               jne     Short @F
;               cmp     Word Ptr es:[si+2],0
;               jne     Short @F

               mov     si,ENTERINT
               shl     si,cl
               cmp     Word Ptr es:[si],0
               jne     Short @F
               cmp     Word Ptr es:[si+2],0
               jne     Short @F

               jmp     Short GOTSR

@@:            mov     RC,91   ; Error 91
               jmp     ERR_EXIT

; Now Set Interrupts to call new TSRs then Old
GOTSR:         mov     es,RUNES
               mov     ah,35h
               mov     al,BIOSINT  ; Copy Int 15h to BIOSNEW
               int     DOS
               mov     ax,es
               mov     Word Ptr FAR15h+2,ax
               mov     Word Ptr FAR15h,bx

               push    ds
               mov     ds,ax
               mov     dx,bx
               mov     ah,25h
               mov     al,BIOSNEW
               int     DOS
               pop     ds

               push    ds      ; BIOS 15h = SYSREQ Start-up
               lds     dx,SYSRQ_FAR
               mov     ah,25h
               mov     al,BIOSINT
               int     DOS
               pop     ds

; Print Screen (Int 5h) 
               mov     es,IVEC_SEG
               mov     si,PSCRNINT  ; Copy Int 5h to PSCRNEW
               mov     cl,2
               shl     si,cl
               mov     ax,es:[si+2]
               mov     bx,es:[si]
               mov     es,RUNES
               mov     Word Ptr FAR5h+2,ax
               mov     Word Ptr FAR5h,bx

               push    ds
               mov     ds,ax
               mov     dx,bx
               mov     ah,25h
               mov     al,PSCRNEW
               int     DOS
               pop     ds

; Replace Int 5h with NEW code (Old ignored, unless Graphics)
               push    ds      ; BIOS 5h = Print Screen
               lds     dx,PSCRN_FAR
               mov     ah,25h
               mov     al,PSCRNINT
               int     DOS
               pop     ds

; Note: RTC Alarm logic removed 3-99 BJr
; Set AT Real-Time Alarm clock and User Alarm Int
;               mov     ch,0h   ; hh BCD (18h = 6pm)
;               mov     cl,0h   ; mm  "
;               xor     dx,dx   ; ss (dh)
;               mov     ax,600h  ; Set Alarm 0:00 (12:00a)
;               int     BIOSRTC

;               mov     ax,700h  ; Disable
;               int     BIOSRTC

;               mov     ah,35h
;               mov     al,ALARMINT  ; Copy Int 4Ah to ALARMNEW
;               int     DOS
;               mov     ax,es
;               mov     Word Ptr FAR4Ah+2,ax
;               mov     Word Ptr FAR4Ah,bx

;               push    ds
;               mov     ds,ax
;               mov     dx,bx
;               mov     ah,25h
;               mov     al,ALARMNEW
;               int     DOS
;               pop     ds

;               push    ds      ; Int 4Ah = SYSREQ Alarm
;               lds     dx,ALARM_FAR
;               mov     ah,25h
;               mov     al,ALARMINT
;               int     DOS
;               pop     ds

; User Ticker Int (18.2 times sec)
; Next line will Skip !!!!!!!!!!!!!!!!!!!
               jmp     Short @F
               mov     es,BIOS_SEG  ; Initial Locks State
               mov     al,Byte Ptr es:[17h]
               and     al,01110000b
               mov     LOCKOLD,al
               mov     es,RUNES

               mov     ax,3400h
               int     DOS
               mov     Word Ptr DOSRECUR,di
               mov     Word Ptr DOSRECUR+2,es
               mov     es,RUNES

;               call    Near Ptr GET_TME  ; Trigger RTC

               mov     ah,35h
               mov     al,UTICKINT  ; Copy Int 1Ch to UTICKNEW
               int     DOS
               mov     ax,es
               mov     Word Ptr FAR1Ch+2,ax
               mov     Word Ptr FAR1Ch,bx

               push    ds
               mov     ds,ax
               mov     dx,bx
               mov     ah,25h
               mov     al,UTICKNEW
               int     DOS
               pop     ds

               push    ds      ; Int 1Ch = SYSREQ Ticker
               lds     dx,UTICK_FAR
               mov     ah,25h
               mov     al,UTICKINT
               int     DOS
               pop     ds

@@:            mov     ah,35h
               mov     al,ENTERINT  ; Save Int 8Eh Vector
               int     DOS
               mov     ax,es
               mov     Word Ptr FAR8Eh+2,ax
               mov     Word Ptr FAR8Eh,bx

               push    ds      ; Int 8Eh = 'Press ENTER'
               lds     dx,ENTER_FAR
               mov     ah,25h
               mov     al,ENTERINT
               int     DOS
               pop     ds

               mov     dx,Offset TSR_MSG  ; Ok
               mov     ah,9
               mov     al,0
               int     DOS

; TSR - Terminate but Stay Resident (Keep Process)
               cli
               mov     dx,SRQPAGES  ; from De-Alloc at startup
               mov     ah,31h
               mov     al,0    ; Exit, Keep Process, RC=0
               mov     TSRFLAG,1  ; Wait till last moment ...
               mov     TICKFLAG,1
               sti
               int     DOS
               ret

; ----------------------------------------------------------------------
; ==> Re-entrant point for Alt+SysRq key  <== Int 15h

;   if  cmp  ax,8501h  = True, then  Alt+SysRQ  Up/Released/Break
;   "    "      8500h  =  "      "       "      Down/Pressed/Make
;   "    "      FFxxh  =  "  , then Call is from Program for Error al

RESTART        Proc    Far
               cmp     ax,8501h  ; Alt+SysRQ Released?
               je      Short SRQKEY
               cmp     ah,0FFh  ; Program Error Request
               je      Short STDERR
               int     BIOSNEW  ; let BIOS know (redirected 15h)
               sti
               iret

SAVERQEDX      DD      0       ; Misc Data
SAVERQBX       DW      0       ; Process Addr
SAVERQDI       DW      0       ; FSpec Addr 
SAVERQES       DW      0       ;  "  {Seg)
SAVERQ         DW      0       ; ax

SRQKEY:        int     BIOSNEW  ; Bios has Priority
               mov     cs:SAVERQ,ax
               jmp     Short I15ALL

STDERR:        mov     cs:SAVERQ,ax
               mov     cs:SAVERQDI,di
               mov     cs:SAVERQES,es
               mov     cs:SAVERQBX,bx
               mov     cs:SAVERQEDX,edx

I15ALL:        cli
               push    ax
               push    ds
               mov     ax,@data
               mov     ds,ax

; TSRFLAG:  0FFh=Loading,  1=Resident/Idle,  2=Running,  3=Abort & Re-Boot
               cmp     TSRFLAG,2  ; attempting Recursion?
               jne     Short @F
               call    Near Ptr SPEAKERR
               pop     ds      ; Yes, Go back
               pop     ax
               sti
               iret

; ==> Caller's DS on stack, DS=Our Data Seg
@@:            cli             ; Stack Seg=Data (Top) 
               mov     SAVESS,ss  ; Do NOT chg order below !
               mov     SAVESP,sp
               mov     ax,RUNSS
               mov     ss,ax
               mov     sp,RUNSP
               sti
               call    Near Ptr SAVE_REGS

;               mov     es,Word Ptr DOSRECUR+2  ; NO Recursion
;               mov     di,Word Ptr DOSRECUR
;               cmp     Byte Ptr es:[di],0
;               je      @F
;               call    Near Ptr SPEAKERR
;               jmp     NO_MODE  ; DOS Active!

@@:            mov     es,RUNES  ; Extra Seg
               cmp     TSRFLAG,1  ; Idle?
               je      Short @F
               mov     TSRFLAG,3
               jmp     AB_TSR  ; if this Hits, TSR Corrupt !

@@:            mov     TSRFLAG,2  ; Running ...
               mov     RC,0
               mov     GRAF_FLAG,0
               mov     ax,Offset ALTSMSG  ; Msg Text
               mov     VTXT_LOC,ax
               mov     es,BIOS_SEG
               mov     ax,es:[4Eh]  ; Page Offset
               mov     VBUF_PGOFS,ax
               mov     es,RUNES
               call    Near Ptr SET_CWID
               mov     si,VBUF_MSG  ; Overlay Msg Loc
               add     si,VBUF_PGOFS
               mov     VBUF_SAV,si
               mov     ax,WAITALT  ; Reset Constants!
               mov     WAITCNT,ax

@@:            mov     ax,VBUF_CO  ; Reset Video Seg
               mov     VBUF_SEG,ax

               mov     ah,15   ; Cur Mode, etc.
               int     BIOSVID
               cmp     al,7    ; Mode 7 is Mono Buffer at B000h
               je      Short @F
               cmp     al,86   ; Mode 86 (VGA)   " ...
               je      Short @F
               cmp     al,87   ; Mode 87   "     " ...
               je      Short @F
               jmp     Short CHK_CO3

@@:            mov     ax,VBUF_MONO  ; Monochrome
               mov     VBUF_SEG,ax
               jmp     Short GOTMODE3

CHK_CO3:       cmp     al,3    ; Modes 0-3 are Color Buff at B800h
               jle     Short GOTMODE3
               cmp     al,84   ; (132 Col VGA)  "
               je      Short GOTMODE3
               cmp     al,85   ;   "            "
               je      Short GOTMODE3

               call    Near Ptr SPEAKERR  ; else Graphics at A000h - BAD!
               mov     GRAF_FLAG,1
               jmp     NO_MODE  ; No Msg

GOTMODE3:      call    Near Ptr GET_TME
               mov     si,Offset ASC_TOD
               mov     di,Offset ALTSTOD
               mov     cx,3
               cld
               rep     movsd

               mov     es,RUNES
               mov     ax,cs:SAVERQ
               cmp     ah,0FFh  ; Error Req?
               jne     Short @F
               call    Near Ptr ERRORS
               jmp     Short NO_MODE

@@:            mov     si,Offset ASC_ALM
               mov     al,0Bh  ; Stat Reg B
               out     70h,al
               in      al,71h
               and     al,00100000b  ; Bit 5 = Enabled
               jnz     Short @F
               mov     si,Offset ALTSALMX  ; Off

@@:            mov     di,Offset ALTSALM
               mov     cx,3
               cld
               rep     movsd

               call    Near Ptr SPEAKERC

               call    Near Ptr SAVE_MSG  ; Save/Display Msg

               mov     COMSTAT,0FFh  ; Flag COM Stat to Display
               mov     cx,10   ; Msb x65536  (Wait 650k uSec, .65 mSec)
               xor     dx,dx   ; Lsb
               xor     bx,bx
               mov     ax,8600h  ; Delay usec
               int     BIOSEXT
               mov     es,BIOS_SEG
               sub     WAITCNT,600

CHKBD:         mov     ax,es:[1Ah]  ; Head Ptr
               cmp     ax,es:[1Ch]  ; Tail Ptr
               jne     Short NOTIME1  ; Unequal = Key
               test    Byte Ptr es:[17h],8  ; Alt?
               jnz     Short NOTIME2

               test    Byte Ptr es:[17h],2  ; L Shft?
               jz      Short @F
               test    Byte Ptr es:[17h],1  ; R Shft? (Need BOTH)
               jnz     Short UNHOOK  ; Yes, Unload

@@:            xor     cx,cx   ; Msb x65536  (Wait 1,000 uSec, 1 mSec)
               mov     dx,1000  ; Lsb
               xor     bx,bx
               mov     ax,8600h  ; Delay usec
               int     BIOSEXT
               dec     WAITCNT
               jnz     CHKBD  ; x Sec Max (See WAITMAX)
               jmp     Short NOTIME2

NOTIME1:       xor     al,al   ; Clear KB
               mov     ah,0Ch
               int     DOS

NOTIME2:       mov     es,RUNES
               call    Near Ptr REST_MSG  ; Restore  <==

; Port 61h = 8253 Timer Channel 2 [ xxxxxx01b = Timer ]
NO_MODE:       call    Near Ptr RESETS
               mov     TSRFLAG,1  ; Toggle from 2-Int to 1-Resident
               call    Near Ptr REST_REGS
               cli
               mov     ss,SAVESS
               mov     sp,SAVESP
               pop     ds
               pop     ax
               cmp     cs:SAVERQ,0
               je      Short @F
               mov     ax,cs:SAVERQ  ; Return Info!
               mov     cs:SAVERQ,0
@@:            sti
               iret

UNHOOK:        call    Near Ptr REST_MSG  ; Restore  <==

               push    ds      ; BIOS 15h = Start-up
               lds     dx,FAR15h
               mov     ah,25h
               mov     al,BIOSINT
               int     DOS
               pop     ds

               push    ds      ; BIOS 5h = Print Screen
               lds     dx,FAR5h
               mov     ah,25h
               mov     al,PSCRNINT
               int     DOS
               pop     ds

               push    ds      ; Int 1Ch = Ticker
               lds     dx,FAR1Ch
               mov     ah,25h
               mov     al,UTICKINT
               int     DOS
               pop     ds

;               push    ds      ; Int 4Ah = Alarm
;               lds     dx,FAR4Ah
;               mov     ah,25h
;               mov     al,ALARMINT
;               int     DOS
;               pop     ds

               push    ds      ; Int 8Eh = Prompt
               lds     dx,FAR8Eh
               mov     ah,25h
               mov     al,ENTERINT
               int     DOS
               pop     ds

               mov     es,IVEC_SEG  ; Clear Re-directed Ints
               mov     di,BIOSNEW
               mov     cl,2
               shl     di,cl
               xor     ax,ax
               stosw
               stosw
               mov     di,UTICKNEW
               shl     di,cl
               stosw
               stosw
               mov     di,ALARMNEW
               shl     di,cl
               stosw
               stosw
               mov     di,PSCRNEW
               shl     di,cl
               stosw
               stosw

               mov     es,RUNES
               call    Near Ptr BEEPIT
               call    Near Ptr WAIT2m
               call    Near Ptr BEEPIT
               call    Near Ptr RESETS

;               mov     es,PSPES  ; Free Environ Seg
;               mov     ax,es:[2Ch]
;               mov     es,ax
;               mov     ah,49h
;               int     DOS
               mov     es,PSPES  ; Free Resident
               mov     bx,SRQPAGES
               mov     ah,49h
               int     DOS
               call    Near Ptr REST_REGS

               cli
               mov     ss,SAVESS
               mov     sp,SAVESP
               pop     ds
               pop     ax
               sti
               iret

; ----------------------------------------------------------------------
; Nested Near Procs - MUST be here!

               Include SysReq.Far  ; Far procs PRTSCRN, ALARM, TICKER

; ----------------------------------------------------------------------
; Error Handler

ERR_SET:       mov     RC,al   ; Save Err #

ERR_EXIT:      mov     al,RC   ; Error #
               cmp     al,0
               jne     Short @F
               jmp     Short EXITP

@@:            mov     es,RUNES
               mov     bx,Offset PROCESS  ; Process Addr
               xor     di,di
               cmp     PBFSA,0
               je      Short @F
               mov     di,PBFSA  ; FSpec Addr

@@:            mov     al,RC
               mov     ah,0FFh  ; Calls Int Routine
               int     BIOSEXT

               cmp     ah,0FFh  ; Ignore?
               je      Short @F
               cmp     ah,0AAh  ; Abort?
               je      Short @F
               cmp     ah,0EEh  ; Retry ?
               jne     Short @F
               call    Near Ptr SPEAKERR

@@:            nop

AB_TSR:        cmp     TSRFLAG,3  ; TSR Corrupt
               jne     Short EXITP

               mov     dx,Offset CRPT_MSG
               mov     ah,09h
               int     DOS

               cli
               pop     ds
               pop     ax
               sti

               mov     ah,08h  ; Wait for any key
               int     DOS

; Go do BIOS Cold Boot ...
               jmp     BOOT

; ----------------------------------------------------------------------
; Exit to DOS

EXITP:         cmp     TSRFLAG,0FFh  ; Loader Exit ?
               je      Short DOS_OUT

               cmp     TSRFLAG,2  ; Running ?
               je      Short @F
               jmp     Short EXITOK  ; No

; Extra Stack level for PrntScrn ?
@@:            cmp     REGFLAG,0  ; File Err/Pgm Stk +1
               je      Short EXITOK
               call    Near Ptr REST_REGS
               mov     REGFLAG,0
               pop     ax

; Port 61h = 8253 Timer Channel 2 [ xxxxxx01b = Timer ]
EXITOK:        call    Near Ptr RESETS
               call    Near Ptr REST_REGS
               cli
               mov     TSRFLAG,1  ; Toggle from 2-Int to 1-Resident
               mov     ss,SAVESS
               mov     sp,SAVESP
               cmp     GRAF_FLAG,1  ; Need Bios
               je      Short @F

               pop     ds
               mov     al,20h  ; Reset In-Svc
               out     20h,al
               pop     ax
               sti
               iret

@@:            pop     ds      ; Here if Graphics, Bios might dump?
               pop     ax
               int     PSCRNEW  ; Call Bios code!
               sti
               iret

; Only Loader Exits here if failed
DOS_OUT:       mov     al,RC   ; ErrorLevel
               mov     ah,4Ch
               int     DOS     ; Exit
               ret

; ----------------------------------------------------------------------
; Called Sub-Routines (cannot use Called.Inc)

; Delay cx usec (Convert cx=n for loop $ to cx /2 usecs)
WAITusec:      cli
               push    ax
               push    bx
               push    dx
               sti

               shr     cx,1
               mov     dx,cx   ; Lsb
               xor     cx,cx   ; Msb x65536
               xor     bx,bx
               mov     ax,8600h  ; Delay usec
               int     BIOSEXT
               xor     cx,cx

               cli
               pop     dx
               pop     bx
               pop     ax
               sti
               retn

; Delay 30 msec (1.5x 'loop $' if cx=0 at 33MHz)
WAIT2m:        push    ax
               push    bx
               push    cx
               push    dx

               xor     cx,cx   ; Msb x65536  (Wait 30k uSec, 30 mSec)
               mov     dx,30000  ; Lsb
               xor     bx,bx
               mov     ax,8600h  ; Delay usec
               int     BIOSEXT

               pop     dx
               pop     cx
               pop     bx
               pop     ax
               retn

; Delay 10 msec (Let RTC latch)
WAIT10m:       xor     cx,cx   ; Msb x65536  (Wait 10k uSec, 10 mSec)
               mov     dx,10000  ; Lsb
               xor     bx,bx
               mov     ax,8600h  ; Delay usec
               int     BIOSEXT
               retn

SET_CWID:      mov     es,BIOS_SEG
               mov     ax,es:[4Ah]  ; Columns
               mov     XCOLS,ax
               mov     es,RUNES

               cmp     XCOLS,40  ; 40 Col Start Offset
               jne     Short @F
               mov     COLWIDTH,0
               mov     COLWIDTH2,36
               mov     VBUF_MSG,800   ; Row 11, Col 1 
               mov     VBUF_ALM,1600  ;  "  21,  "  1
               mov     VBUF_ENT,1636  ;  "  21,  "  18

@@:            cmp     XCOLS,80  ; 80 Col Start Offset
               jne     Short @F
               mov     COLWIDTH,80
               mov     COLWIDTH2,116
               mov     VBUF_MSG,1640  ; Row 11, Col 21 
               mov     VBUF_ALM,3276  ;  "  21,  "  39
               mov     VBUF_ENT,3312  ;  "  21,  "  57

@@:            cmp     XCOLS,132  ; 132 Col Start Offset
               jne     Short @F
               mov     COLWIDTH,184
               mov     COLWIDTH2,220
               mov     VBUF_MSG,2732  ; Row 11, Col 47 
               mov     VBUF_ALM,5460  ;  "  21,  "  91
               mov     VBUF_ENT,5496  ;  "  21,  "  109

@@:            retn

SAVEIT:        push    cx      ; Save 1 Scr Line (VBuf to Data)
               shr     cx,1
               cld
               rep     movsd
               add     si,dx   ; Next Row (DS = Video)
               pop     cx
               retn

COPYIT:        push    cx      ; Copy 1 Msg line (Data to VBuf)
               cld
@@:            lodsb
               stosw
               loop    @B
               add     di,COLWIDTH  ; Next Row
               pop     cx
               retn

MOVEIT:        push    cx      ; Restore 1 Scr Line (Data to VBuf)
               shr     cx,1
               cld
               rep     movsd
               add     di,COLWIDTH  ; Next Row
               pop     cx
               retn

COPYIT2:       push    cx      ; Copy 1 Msg line (Data to VBuf)
               cld
@@:            lodsb
               stosw
               loop    @B
               add     di,COLWIDTH2  ; Next Row
               pop     cx
               retn

; Delay Loop   In  cx = Counter
WAITER:        push    cx

@@:            call    Near Ptr WAIT2m
               test    Byte Ptr es:[17h],8  ; Alt?
               jnz     Short @F

               pop     cx      ; Next count
               dec     cx
               push    cx
               jnz     Short @B

@@:            pop     cx      ; Stack adjust
               retn

; Save Screen Text then Display Message
SAVE_MSG:      push    ax
               push    cx
               push    si
               push    di

               mov     es,RUNES
               mov     si,VBUF_SAV  ; VBuff Offset
               mov     di,Offset DTASAVE  ; Save Old
               mov     cx,MSGCOLS
               mov     dx,COLWIDTH
               push    ds    
               mov     ax,VBUF_SEG
               mov     ds,ax
; Note DS = VBUF_SEG here
               call    Near Ptr SAVEIT  ; Line 1
               call    Near Ptr SAVEIT  ;  "   2
               call    Near Ptr SAVEIT  ;  "   3
               call    Near Ptr SAVEIT  ;  "   4
               call    Near Ptr SAVEIT  ;  "   5
               pop     ds
; Note DS = Data here

               mov     si,VTXT_LOC  ; Selected Msg
               mov     ah,CO_MSG  ; Attrib
               mov     es,VBUF_SEG
               mov     di,VBUF_SAV
               mov     cx,MSGCOLS
               call    Near Ptr COPYIT  ; 1st Msg Line
               call    Near Ptr COPYIT  ; 2nd  "
               call    Near Ptr COPYIT  ; 3rd  "
               call    Near Ptr COPYIT  ; 4th  "
               call    Near Ptr COPYIT  ; 5th  "
               mov     es,RUNES

               pop     di
               pop     si
               pop     cx
               pop     ax
               retn

; Restore Screen Text
REST_MSG:      push    ax
               push    cx
               push    si
               push    di

               mov     si,Offset DTASAVE  ; Restore Msg Area
               mov     es,VBUF_SEG
               mov     di,VBUF_SAV
               mov     cx,MSGCOLS
               call    Near Ptr MOVEIT  ; Line 1
               call    Near Ptr MOVEIT  ;  "   2
               call    Near Ptr MOVEIT  ;  "   3
               call    Near Ptr MOVEIT  ;  "   4
               call    Near Ptr MOVEIT  ;  "   5
               mov     es,RUNES

               pop     di
               pop     si
               pop     cx
               pop     ax
               retn

; Save Screen Text then Display Message
SAVE_MSG2:     push    ax
               push    cx
               push    si
               push    di

               mov     es,RUNES
               mov     si,VBUF_SAV  ; VBuff Offset
               mov     di,Offset DTASAVE  ; Save Old
               mov     cx,MSGCOLS
               mov     dx,COLWIDTH
               push    ds    
               mov     ax,VBUF_SEG
               mov     ds,ax
; Note DS = VBUF_SEG here
               call    Near Ptr SAVEIT  ; Line 1
               call    Near Ptr SAVEIT  ;  "   2
               call    Near Ptr SAVEIT  ;  "   3
               call    Near Ptr SAVEIT  ;  "   4
               call    Near Ptr SAVEIT  ;  "   5
               pop     ds
; Note DS = Data here

               mov     si,VTXT_LOC  ; Selected Msg
               mov     ah,CO_MSG  ; Attrib
               mov     es,VBUF_SEG
               mov     di,VBUF_SAV
               mov     cx,MSGCOLS2
               call    Near Ptr COPYIT2  ; 1st Msg Line
               call    Near Ptr COPYIT2  ; 2nd  "
               call    Near Ptr COPYIT2  ; 3rd  "
               call    Near Ptr COPYIT2  ; 4th  "
               call    Near Ptr COPYIT2  ; 5th  "
               mov     es,RUNES

               pop     di
               pop     si
               pop     cx
               pop     ax
               retn

; Reset Timer chip Channel 2
RESETS:        push    ax
               in      al,61h
               and     al,0FCh 
               or      al,1
               out     61h,al
               pop     ax
               retn

; Alarm Tone (Repetitive)
TONEIT:        mov     es,BIOS_SEG

SLOT:          mov     bx,4     ; Count/# tones
               retn

TONE:          mov     dx,100   ;  Duration of Tone
               in      al,61h   ; Read 8255 Port B
               and     al,0FEh  ;  Turn 8253 Timer OFF

@@:            or      al,2     ;  Turn Speaker ON
               out     61h,al   ; Write Port B
               mov     cx,200   ;  Duration HI
               call    Near Ptr WAITusec

               and     al,0FDh  ;  Turn Speaker OFF
               out     61h,al   ; Write Port B
               mov     cx,800  ;  Duration LO
               call    Near Ptr WAITusec
               test    Byte Ptr es:[17h],8  ; Alt?
               jnz     Short @F

               dec     dx       ;  Cycle Count
               jnz     Short @B       ; Repeat Wave

               call    Near Ptr WAIT2m
               test    Byte Ptr es:[17h],8  ; Alt?
               jnz     Short @F

               dec     bx       ;  Tone Count
               jnz     Short TONE     ; Next Tone

@@:            retn

; Beep Speaker    cx = 1/2 Freq if Tone    dx = Duration
BEEPIT:        retn
               cli
               push    dx
               push    cx
               push    ax
               sti

               mov     dx,80   ;Repeat
               in      al,61h
               and     al,0FEh
@@:            or      al,2
               out     61h,al
               mov     cx,600  ;On
               call    Near Ptr WAITusec
               and     al,0FDh
               out     61h,al
               mov     cx,800  ;Off
               call    Near Ptr WAITusec

               dec     dx
               jnz     Short @B

               cli
               pop     ax
               pop     cx
               pop     dx
               sti
               retn

; Beep Thrice for Errors
SPEAKERR:      retn
               push    cx
               call    Near Ptr BEEPIT
               call    Near Ptr WAIT2m
               call    Near Ptr BEEPIT
               call    Near Ptr WAIT2m
               call    Near Ptr BEEPIT
               pop     cx
               retn 

; Click speaker
SPEAKERC:      retn
               push    ax
               push    bx
               push    cx
               push    dx

               mov     bx,5    ; Count
DOCLIK:        mov     dx,20   ; Duration
               in      al,61h
               and     al,0FEh
@@:            or      al,2    ; On
               out     61h,al
               mov     cx,100   ; Cycles
               call    Near Ptr WAITusec
               and     al,0FDh ; Off
               out     61h,al
               mov     cx,800  ; Cycles
               call    Near Ptr WAITusec

               dec     dx
               jnz     Short @B
               call    Near Ptr WAIT2m

               dec     bx      ; Next
               jnz     Short DOCLIK

               pop     dx
               pop     cx
               pop     bx
               pop     ax
               retn

; Chime/Ring on the Hour
CHIME:         retn
               push    ax
               push    bx
               push    cx
               push    dx

TONE1:         mov     dx,40   ;  Duration of Tone
               in      al,61h  ; Read 8255 Port B
               and     al,0FEh  ;  Turn 8253 Timer OFF
@@:            or      al,2    ;  Turn Speaker ON
               out     61h,al  ; Write Port B
               mov     cx,100  ;  Duration HI
               call    Near Ptr WAITusec
               and     al,0FDh  ;  Turn Speaker OFF
               out     61h,al  ; Write Port B
               mov     cx,100  ;  Duration LO
               call    Near Ptr WAITusec

               mov     cx,1000
               call    Near Ptr WAITusec
               dec     dx      ;  Cycle Freq
               jnz     Short @B      ; Repeat Wave

               mov     dx,40   ;  Duration of Tone
@@:            or      al,2    ;  Turn Speaker ON
               out     61h,al  ; Write Port B
               mov     cx,200  ;  Duration HI
               call    Near Ptr WAITusec
               and     al,0FDh  ;  Turn Speaker OFF
               out     61h,al  ; Write Port B
               mov     cx,200  ;  Duration LO
               call    Near Ptr WAITusec

               mov     cx,1000
               call    Near Ptr WAITusec
               dec     dx      ;  Cycle Freq
               jnz     Short @B      ; Repeat Wave

               dec     bx      ;  Tone Count
               jnz     Short TONE1   ; Next Tone

               pop     dx
               pop     cx
               pop     bx
               pop     ax
               retn

; Rising Tone on Speaker (Whoop Up)
TRISE:         retn
               push    ax
               push    cx
               push    dx

               mov     cx,502
               push    cx
               mov     dx,128  ; Repeat rising
               in      al,61h
               and     al,0FEh
@@:            or      al,2
               out     61h,al
               pop     cx      ; On
               sub     cx,2
               push    cx
               call    Near Ptr WAITusec
               and     al,0FDh
               out     61h,al
               mov     cx,500  ; Off
               call    Near Ptr WAITusec

               dec     dx
               jnz     Short @B
               pop     cx      ; Adj Stk

               pop     dx
               pop     cx
               pop     ax
               retn

; Falling Tone on Speaker (Whoop Down)
TFALL:         retn
               push    ax
               push    cx
               push    dx

               mov     cx,802
               push    cx
               mov     dx,96   ; Repeat Falling
               in      al,61h
               and     al,0FEh
@@:            or      al,2
               out     61h,al
               pop     cx      ; On
               add     cx,2
               push    cx
               call    Near Ptr WAITusec
               and     al,0FDh
               out     61h,al
               mov     cx,500  ; Off
               call    Near Ptr WAITusec

               dec     dx
               jnz     Short @B
               pop     cx      ; Adj Stk

               pop     dx
               pop     cx
               pop     ax
               retn

; Set Time of Day in RTCBIN from RTC
SET_TOD:       push    ax
               push    bx
               push    di

@@:            mov     al,0Ah  ; Wait if Updating!
               out     70h,al
               in      al,71h
               test    al,128
               jnz     Short @B

               cli
               mov     bx,6    ; RTC Reg#/Offset
@@:            mov     ax,bx
               dec     ax
               mov     di,ax
               out     70h,al
               in      al,71h
               mov     RTCBIN[di],al
               dec     bx
               jnz     Short @B
               sti

               pop     di
               pop     bx
               pop     ax
               retn

; GET_TME  Get System Time
;  Out  BIN_TOD = Binary Time (hmsH)    ASC_TOD = ASCII Time (hh:mm:ss)
;       BIN_ALM =  "  (h)               ASC_ALM =  "

GET_TME:       call    Near Ptr SAVE_REGS

               mov     ah,2Ch
               int     DOS
               mov     bx,OFFSET BIN_TOD ; DOS Clock
               mov     [bx],ch    ; Hour
               mov     [bx+1],cl  ; Minute
               mov     [bx+2],dh  ; Seconds
               mov     [bx+3],dl  ; Hund/Sec

               call    Near Ptr SET_TOD  ; AT RTC

               mov     al,RTCBIN+5  ; hh Alarm
               mov     ah,al
               mov     cl,4
               shr     al,cl
               and     ah,0Fh
               push    ax
               add     al,48
               add     ah,48
               mov     Word Ptr ASC_ALM,ax
               mov     al,RTCBIN+3  ; mm
               mov     ah,al
               shr     al,cl
               and     ah,0Fh
               add     al,48
               add     ah,48
               mov     Word Ptr ASC_ALM+3,ax
               mov     al,RTCBIN+1  ; ss
               mov     ah,al
               shr     al,cl
               and     ah,0Fh
               add     al,48
               add     ah,48
               mov     Word Ptr ASC_ALM+6,ax

               pop     ax
               push    ax
               xor     ah,ah
               mov     cl,10
               mul     cl
               xor     ah,ah
               mov     bl,al
               pop     ax
               mov     al,ah
               add     al,bl
               mov     BIN_ALM,al

               mov     MIDALARM+1,'a'
               cmp     BIN_ALM,12
               jl      Short OKALRM
               mov     MIDALARM+1,'p'
               cmp     BIN_ALM,12
               je      Short OKALRM
               sub     ASC_ALM,1
               cmp     ASC_ALM+1,'2'
               jge     Short @F
               sub     ASC_ALM,1
               add     ASC_ALM+1,10

@@:            sub     ASC_ALM+1,2

OKALRM:        cmp     ASC_ALM,'0'
               jne     Short @F
               mov     ASC_ALM,' '

@@:            mov     al,RTCBIN+4  ; hh Time
               mov     ah,al
               mov     cl,4
               shr     al,cl
               and     ah,0Fh
               push    ax
               add     al,48
               add     ah,48
               mov     Word Ptr ASC_TOD,ax
               mov     al,RTCBIN+2  ; mm
               mov     ah,al
               shr     al,cl
               and     ah,0Fh
               add     al,48
               add     ah,48
               mov     Word Ptr ASC_TOD+3,ax
               mov     al,RTCBIN+0  ; ss
               mov     ah,al
               shr     al,cl
               and     ah,0Fh
               add     al,48
               add     ah,48
               mov     Word Ptr ASC_TOD+6,ax

               pop     ax
               push    ax
               xor     ah,ah
               mov     cl,10
               mul     cl
               xor     ah,ah
               mov     bl,al
               pop     ax
               mov     al,ah
               add     al,bl
               mov     BIN_TOD,al

               mov     MIDNIGHT+1,'a'
               cmp     BIN_TOD,12
               jl      Short OKTIME
               mov     MIDNIGHT+1,'p'
               cmp     BIN_TOD,12
               je      Short OKTIME
               sub     ASC_TOD,1
               cmp     ASC_TOD+1,'2'
               jge     Short @F
               sub     ASC_TOD,1
               add     ASC_TOD+1,10

@@:            sub     ASC_TOD+1,2

OKTIME:        cmp     ASC_TOD,'0'
               jne     Short @F
               mov     ASC_TOD,' '

@@:            call    Near Ptr REST_REGS
               retn

;  BIN_DEC1  Convert Binary to ASCII Decimal
; In: ZBYTE = Bin Val (hh)    Out: DECIMAL+5 = ASCII Dec (nnn)

BIN_DEC1:      call    Near Ptr SAVE_REGS
               xor     ax,ax
               xor     bx,bx
               mov     al,ZBYTE
; Here from BIN_DEC2
BIN_DEC:       mov     cx,100          ;Hunds
               div     cl
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+5,al
               mov     al,ah           ;Tens
               xor     ah,ah
               mov     cx,10
               div     cl
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+6,al
               mov     bl,ah           ;Ones
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+7,al

               cmp     DECIMAL+5,'0'  ; Zero suppress
               jne     Short @F
               mov     DECIMAL+5,' '
               cmp     DECIMAL+6,'0'
               jne     Short @F
               mov     DECIMAL+6,' '

@@:            call    Near Ptr REST_REGS
               retn

;  BIN_DEC2  Convert Binary to ASCII Decimal
; In: ZWORD = Bin Val (hhhh)    Out: DECIMAL+3 = ASCII Dec (nnnnn)

BIN_DEC2:      call    Near Ptr SAVE_REGS
               xor     bx,bx
               xor     dx,dx
               mov     ax,ZWORD
               mov     cx,10000        ;Ten Thous
               div     cx
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+3,al
               mov     ax,dx           ;Thous
               xor     dx,dx
               mov     cx,1000
               div     cx
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+4,al
               mov     ax,dx           ;Hunds

               jmp     BIN_DEC

;  Save/Restore ax, cx, dx, bx, bp, si, di, ds, es
SAVE_REGS:     cli
               push    ax
               push    bx
               mov     bx,IRADDR
               cmp     Word Ptr [bx],0FFFFh
               jne     Short @F
               pop     bx
               pop     ax
               sti
               mov     TSRFLAG,3
               mov     RC,95   ; Stack
               jmp     ERR_EXIT

@@:            sti
               mov     [bx],ax
               mov     [bx+2],cx
               mov     [bx+4],dx
               pop     ax      ; bx
               push    ax
               mov     [bx+6],ax  ; bx
               mov     [bx+8],bp
               mov     [bx+10],si
               mov     [bx+12],di
               mov     [bx+14],ds
               mov     [bx+16],es
               add     bx,18
               mov     IRADDR,bx
               pop     bx
               pop     ax
               retn

REST_REGS:     cli
               mov     ax,@data
               mov     ds,ax
               sti
               mov     bx,IRADDR
               sub     bx,18
               mov     IRADDR,bx
               mov     ax,[bx]
               push    ax
               mov     Word Ptr [bx],0  ; in case FF!
               mov     cx,[bx+2]
               mov     dx,[bx+4]
               mov     bp,[bx+8]
               mov     si,[bx+10]
               mov     di,[bx+12]
               mov     ax,[bx+14]
               push    ax      ; ds
               mov     ax,[bx+16]
               mov     es,ax
               mov     ax,[bx+6]
               mov     bx,ax
               pop     ds
               pop     ax
               retn

RESTART        EndP

; ----------------------------------------------------------------------
;  Need for TSR (Keep Process) calculation of Pages (16 bytes each)

               Align   16
               End     Start           ;Start Addr!
;*** End of Program ***

